#include <algorithm>
#include <chrono>
#include <condition_variable>
#include <iostream>
#include <mutex>
#include <thread>
#include <queue>

//----------------------------------------------------------------------------

class QueueException {
    std::string str;
public:
    QueueException(const std::string& s) : str(s) {}
    ~QueueException() {}
};

template <class E> 
class SafeUnboundedQueueLock {
        std::queue<E> elements;
        std::mutex lock;
    public: 
        SafeUnboundedQueueLock<E>(){}
        void push(const E& element);
        E pop_nonblocking();
        E pop_blocking(); // Exercise 2
        bool is_empty() const {return this->elements.empty();}
};

template <class E>
void SafeUnboundedQueueLock<E>::push(const E& element) {
}

template <class E> 
E SafeUnboundedQueueLock<E>::pop_nonblocking() {
}

template <class E> 
E SafeUnboundedQueueLock<E>::pop_blocking() {
    // Exercise 2
}

//----------------------------------------------------------------------------

void DivideOnceEven(std::condition_variable& iseven, std::mutex& m, int& n) {
}

//-----------------------------------------------------------------------------

template <class E> 
class SafeUnboundedQueueCV {
        std::queue<E> elements;
        std::mutex lock;
        std::condition_variable not_empty;
    public: 
        SafeUnboundedQueueCV<E>(){}
        void push(const E& element);
        E pop ();
        bool is_empty() const {return this->elements.empty();}
};

template <class E>
void SafeUnboundedQueueCV<E>::push(const E& element) {
}

template <class E> 
E SafeUnboundedQueueCV<E>::pop() {
}

//-----------------------------------------------------------------------------
